import type { ClaimFormat } from '../../W3cCredentialServiceOptions';
import { W3cJsonLdVerifiableCredential } from '../../data-integrity/models/W3cJsonLdVerifiableCredential';
import { W3cJwtVerifiableCredential } from '../../jwt-vc/W3cJwtVerifiableCredential';
export declare function W3cVerifiableCredentialTransformer(): PropertyDecorator;
export type W3cVerifiableCredential<Format extends Extract<ClaimFormat, 'jwt_vc' | 'ldp_vc'> | unknown = unknown> = Format extends 'jwt_vc' ? W3cJsonLdVerifiableCredential : Format extends 'ldp_vc' ? W3cJwtVerifiableCredential : W3cJsonLdVerifiableCredential | W3cJwtVerifiableCredential;
